;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;                                                          ;;;;;;;;
;;;;;;  All files in this directory or any subdirectories are   ;;;;;;;;
;;;;;;  copyright 1997, 1998, 1999, 2000, 2002, 2003.           ;;;;;;;;
;;;;;;  by Rafael D. Sorkin.  All rights reserved.              ;;;;;;;;
;;;;;;                                                          ;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; This is bibliotek.general.tcl.l, a "sub-bibliotek" of bibliotek.general.l
;; It contains functions whose TCL and elisp definitions differ.
;; If a function has different TCL versions for different dialects, then it
;; should be found in sub-sub-biblioteks of bibliotek.general
;;    
;; This file is loaded AFTER bibliotek.general.l but BEFORE sub-sub-biblioteks
;; like bibliotek.general.gcl

;; NOTE defun's not at top level seem not to get compiled by gcl! (what about
;; TCL in general?)

(defun mean (L)  
  "\
 The arithmetic mean of a list of numbers.
 This is the TCL version which is exact if the numbers are rational"
  (/ 
   (sum-m L)
   (length L)))

(defun sup (seq)
  "\
 Maximum of the numbers in a sequence.  This is just like `max' but 
 instead of multiple arguments it takes a single sequence."
  (loop for x in (coerce seq 'list) maximize x))

(defun inf (seq)
  " Minimum of the numbers in a sequence. "
  (loop for x in (coerce seq 'list) minimize x))

;: End
